package Shared;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.zip.CRC32;
import java.util.zip.Checksum;

public class CheckSum {
	private static final int BUFFER_SIZE = 2048;

	public static long getCRC32(String file) throws IOException{
		BufferedInputStream stream = new BufferedInputStream(new FileInputStream(new File(file)));
		Checksum checksum = new CRC32();
		
		byte[] buffer = new byte[BUFFER_SIZE];
		int len;
		
		while((len=stream.read(buffer, 0, BUFFER_SIZE)) != -1)
			checksum.update(buffer, 0, len);
		
		return checksum.getValue();
	}
}
