import java.util.Observable;

public class Paragraph extends Observable {
    private String [] lines;
    private int count_lines;
   
    /** Creates a new instance of Paragraph */
    public Paragraph(int lenght, Counter c) {
        lines = new String [lenght];
        count_lines=0;
        addObserver(c);
    }
    
   /** return the line at the ith position*/
    public String getLine(int i) {
        return lines[i];
    }
    
    /** returns the accounts of lines on the paragraph*/
    public int getCountLines() {
        return count_lines;
    }
            
    /** append string s */
    public void addLine(String s) {
        lines[count_lines]=s;
        count_lines=count_lines+1;
        setChanged();
        notifyObservers();
    }
    
    /**
     * align the paragraph by using some of the align algorithms
     * @param f an instance of the concrete formatter class to use
     */
    public String[] align (Formatter f) {
        return f.align(lines);  
    }
}
